//
//  ViewController.m
//  bangbang
//
//  Created by Peter Drescher on 6/10/12.
//  Copyright (c) 2012 Twittering Machine. All rights reserved.
//

#import "ViewController.h"

@implementation ViewController

@synthesize aimSlider;
@synthesize fmodAudio;

- (void)viewDidLoad
{
    [super viewDidLoad];
    fmodAudio = [[FMODaudio alloc] init];
    [fmodAudio FMODviewDidLoad];
    trackRect = [aimSlider trackRectForBounds:aimSlider.bounds];
    thumbRect = [aimSlider thumbRectForBounds:aimSlider.bounds trackRect:trackRect value:aimSlider.value];
    
    CGRect applicationFrame = [[UIScreen mainScreen] applicationFrame];
    applicationFrame.size.height = aimSlider.frame.origin.y - thumbRect.size.height;
    levelView = [[LevelView alloc] initWithFrame:applicationFrame];

    [levelView setFocalPt:focalPoint.center];
    aimThumbPt.x = aimSlider.frame.origin.x + thumbRect.origin.x + ((int)(thumbRect.size.width / 2));
    aimThumbPt.y = aimSlider.frame.origin.y - ((int)thumbRect.size.width / 2);
    oppositeSide = aimThumbPt.y - focalPoint.center.y;
    [levelView setThumbPt:aimThumbPt];
    [levelView setFMODaudio:fmodAudio];
    [self.view addSubview:levelView];
        
    gameLoop = [NSTimer scheduledTimerWithTimeInterval:0.05 target:self selector:@selector(gameLoop) userInfo:nil repeats:YES];
}

- (void)viewWillAppear:(BOOL)animated
{
    [fmodAudio FMODviewWillAppear];
}

- (void) gameLoop
{
    [self drawAimingLine];
    [levelView setNeedsDisplay];
}

- (void) drawAimingLine
{
    float sliderRange = aimSlider.frame.size.width - aimSlider.currentThumbImage.size.width;
    float sliderOrigin = aimSlider.frame.origin.x + (aimSlider.currentThumbImage.size.width / 2.0);
    float sliderValueToPixels = (aimSlider.value * sliderRange) + sliderOrigin;
    aimThumbPt.x = sliderValueToPixels;
    [levelView setThumbPt:aimThumbPt];
}

- (IBAction)takeAim:(UISlider *)sender;
{
//    NSLog(@"taking aim");
}

- (IBAction)fireCannon:(UISlider *)sender;
{
    float adjacentSide = aimSlider.center.x - aimThumbPt.x;
    float angle = atan2f(oppositeSide, adjacentSide);
    [levelView fireCannon:angle];
}

- (void) viewWillDisappear:(BOOL)animated       
{
    [fmodAudio FMODviewWillDisappear];
}

- (void) dealloc
{
    [aimSlider release];
    [levelView release]; 
    [fmodAudio release]; 
    [gameLoop invalidate];
    [super dealloc];
}

@end
